/*
This software(G-Sudoku) is a work from yzonesoft, released under GNU GPL licence.
The things you are not allowed to do are the following,
1) Removing my credits in any part of the software
2) saying that all this software is yours 
* read GNU GPL licence for more info
* also read the GNU GPL licence faq

   __  __
  \  \/ / 
   \ / /   ___   __     __    __      ___   __  ___  __          __    __   __
    | |      /  |  |  |/  |  |_      \__   |  |  |  |_   |   |  /__\  |__| |_
    |_|    /__  |__|  |   |  |__      __/  |__|  |  |    \/\/   |  |  | \  |__

   yzonesoft@yahoo.com                              Copyright (C) 2005  Yogesh       
   http://www.yzonesoft.com

for info about compiling this software read readme.txt

Copyright (C) 2005  Yzone software
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

#include "stdio.h"
#include <gtk/gtk.h>
#include "gsudoku.h"


GtkWidget *tmp_message_dialog;
GtkWidget *game_selection_dialog;


/*
void menu_change_auto_pencil_in (GtkAction *action)
void menu_change_auto_conflict_check (GtkAction *action)
void menu_change_board_size (GtkAction *action, GtkRadioAction *current)
void menu_change_number_of_players (GtkAction *action, GtkRadioAction *current)
void menu_change_time_game (GtkAction *action)
gboolean export_as_png(GtkWidget *widget)
gboolean open_saved_game(GtkWidget *widget)
gboolean save_game(GtkWidget *widget)
gboolean selection_handle_text_entry(GtkWidget *text_entry,  GdkEventKey *event, gpointer data)
gboolean select_game(GtkWidget *widget)
gboolean delete_event( GtkWidget *widget, GdkEvent  *event, gpointer   data )
gboolean expose_event( GtkWidget *widget, GdkEventExpose *event )
gboolean goto_editor(GtkWidget *widget)
gboolean solve(GtkWidget *widget)
gboolean check_conflicts(GtkWidget *widget)
gpointer solver_thread2(gpointer data)
gboolean play(GtkWidget *widget)
gboolean check_the_solution(GtkWidget *widget)
gboolean one_player_game(GtkWidget *widget)
gboolean two_player_game(GtkWidget *widget)
gboolean new_random_game(GtkWidget *widget)
*/

//8888888888888888888888888888888888888888888888888888888888888888888888888888888888888888888
//88menu_change_auto_pencil_in888888888888888888888888888888888888888888888888888888888888888

void menu_change_auto_pencil_in (GtkAction *action)
{
  
  if(settings_widget==NULL)
  {
    if(gtk_toggle_action_get_active(GTK_TOGGLE_ACTION(action)) )
      global.auto_pencil_in_remove=TRUE;
    else
      global.auto_pencil_in_remove=FALSE;

    save_settings_to_file();
  }
  else
  {
    if(global.auto_pencil_in_remove==TRUE)
     gtk_toggle_action_set_active(GTK_TOGGLE_ACTION(gtk_action_group_get_action(actions,
                                                      (const gchar*)"AutoRemovePencilin")),TRUE);
    else
      gtk_toggle_action_set_active(GTK_TOGGLE_ACTION(gtk_action_group_get_action(actions,
                                                      (const gchar*)"AutoRemovePencilin")),FALSE);
  }

}

//88menu_change_auto_pencil_in888888888888888888888888888888888888888888888888888888888888888
//88menu_change_auto_conflict_check8888888888888888888888888888888888888888888888888888888888

void menu_change_auto_conflict_check (GtkAction *action)
{
  if(settings_widget==NULL)
  {
    if(gtk_toggle_action_get_active(GTK_TOGGLE_ACTION(action)) )
      global.check_for_conflictF=TRUE;
    else
      global.check_for_conflictF=FALSE;

    save_settings_to_file();
  }
  else
  {
    if(global.check_for_conflictF==TRUE)
     gtk_toggle_action_set_active(GTK_TOGGLE_ACTION(gtk_action_group_get_action(actions,
                                                      (const gchar*)"AutoCheckConflicts")),TRUE);
    else
     gtk_toggle_action_set_active(GTK_TOGGLE_ACTION(gtk_action_group_get_action(actions,
                                                      (const gchar*)"AutoCheckConflicts")),FALSE);
  }
}

//88menu_change_auto_conflict_check8888888888888888888888888888888888888888888888888888888888
//88menu_change_board_size8888888888888888888888888888888888888888888888888888888888888888888

void menu_change_board_size (GtkAction *action, GtkRadioAction *current)
{
  if(settings_widget==NULL)
  {
    if(gtk_radio_action_get_current_value(current)==0 )
      board_size_original=3;
    else
      board_size_original=4;

    save_settings_to_file();
  }
  else
  {
       
    if(board_size_original==3)
      gtk_toggle_action_set_active (GTK_TOGGLE_ACTION(gtk_action_group_get_action(actions,                                               (const gchar*)"three")), TRUE);
    else
      gtk_toggle_action_set_active (GTK_TOGGLE_ACTION(gtk_action_group_get_action(actions,                                               (const gchar*)"four")), TRUE);
   }
}

//88menu_change_board_size8888888888888888888888888888888888888888888888888888888888888888888
//88menu_change_number_of_players888888888888888888888888888888888888888888888888888888888888

void menu_change_number_of_players (GtkAction *action, GtkRadioAction *current)
{
  
  if(settings_widget==NULL)
  {
    if(gtk_radio_action_get_current_value(current)==0 )
      global.two_player_gameF=FALSE;
    else
      global.two_player_gameF=TRUE;

    save_settings_to_file();
  }
  else
  {
     if(global.two_player_gameF==TRUE)
       gtk_toggle_action_set_active (GTK_TOGGLE_ACTION(gtk_action_group_get_action(actions, (const gchar*)"two")), TRUE);
     else
       gtk_toggle_action_set_active (GTK_TOGGLE_ACTION(gtk_action_group_get_action(actions,  (const gchar*)"one")), TRUE);
  }


     if(global.two_player_gameF==TRUE)
     {
       if(global.two_player_time_game==TRUE)
         gtk_toggle_action_set_active (GTK_TOGGLE_ACTION(gtk_action_group_get_action(actions,                                               (const gchar*)"TimeGame")), TRUE);
       else
         gtk_toggle_action_set_active (GTK_TOGGLE_ACTION(gtk_action_group_get_action(actions,                                               (const gchar*)"TimeGame")), FALSE);
     }  
     else
     {
       if(global.time_race==TRUE)
         gtk_toggle_action_set_active (GTK_TOGGLE_ACTION(gtk_action_group_get_action(actions,                                               (const gchar*)"TimeGame")), TRUE);
       else
         gtk_toggle_action_set_active (GTK_TOGGLE_ACTION(gtk_action_group_get_action(actions,                                               (const gchar*)"TimeGame")), FALSE);
    }




}

//88menu_change_number_of_players888888888888888888888888888888888888888888888888888888888888
//88menu_change_time_game88888888888888888888888888888888888888888888888888888888888888888888

void menu_change_time_game (GtkAction *action)
{
  
  if(settings_widget==NULL)
  {
    if(global.two_player_gameF==TRUE)
    {
      if(gtk_toggle_action_get_active(GTK_TOGGLE_ACTION(action)) )
       global.two_player_time_game=TRUE;
      else
       global.two_player_time_game=FALSE;
    }
    else
    {
      if(gtk_toggle_action_get_active(GTK_TOGGLE_ACTION(action)) )
       global.time_race=TRUE;
      else
       global.time_race=FALSE;
    }
    save_settings_to_file();
  }
  else
  {
     if(global.two_player_gameF==TRUE)
     {
       if(global.two_player_time_game==TRUE)
         gtk_toggle_action_set_active (GTK_TOGGLE_ACTION(gtk_action_group_get_action(actions,                                               (const gchar*)"TimeGame")), TRUE);
       else
         gtk_toggle_action_set_active (GTK_TOGGLE_ACTION(gtk_action_group_get_action(actions,                                               (const gchar*)"TimeGame")), FALSE);
     }
     else
     {
       
       if(global.time_race==TRUE)
         gtk_toggle_action_set_active (GTK_TOGGLE_ACTION(gtk_action_group_get_action(actions,                                               (const gchar*)"TimeGame")), TRUE);
       else
         gtk_toggle_action_set_active (GTK_TOGGLE_ACTION(gtk_action_group_get_action(actions,                                               (const gchar*)"TimeGame")), FALSE);
     }
  }

}

//88menu_change_time_game88888888888888888888888888888888888888888888888888888888888888888888
//88export_as_png8888888888888888888888888888888888888888888888888888888888888888888888888888

gboolean export_as_png(GtkWidget *widget)
{

  GtkWidget *export_puzzle;
  
  chdir("export_dir");
    
  export_puzzle = gtk_file_chooser_dialog_new ("Export Puzzle",
                                      NULL,
                                      GTK_FILE_CHOOSER_ACTION_SAVE,
                                      GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
                                      GTK_STOCK_SAVE, GTK_RESPONSE_ACCEPT,
                                      NULL);

  if(gtk_dialog_run (GTK_DIALOG (export_puzzle)) == GTK_RESPONSE_ACCEPT)
  {
    
    GdkPixbuf *pixbuf;
    GdkColorspace colorspace=GDK_COLORSPACE_RGB;
    GError *error=NULL;
    GdkPixmap *tmp_pxmp;
    char *filename;
    char filename2[255];
    int text_w;
    int text_h;
  
    char ch[255];
    PangoLayout *layout;
    PangoFontDescription *fontdesc;

    
    filename = gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (export_puzzle));
    strcpy(filename2,filename);
    strcat(filename2,".png");
    
    tmp_pxmp = gdk_pixmap_new(drawing_area->window, drawing_area_w, drawing_area_h, -1);
    
    gdk_draw_drawable (tmp_pxmp,drawing_area->style->fg_gc[GTK_WIDGET_STATE (drawing_area)], pixmap, 0, 0, 0, 0, drawing_area_w, drawing_area_h);

      
    gdk_draw_rectangle (tmp_pxmp,drawing_area->style->bg_gc[GTK_STATE_NORMAL],TRUE,0,0,    drawing_area_w,puzzle_box_y);

    if(global.edit_modeF==TRUE)
    strcpy(ch,"#Editor mode");
    else
    {
      unsigned long tmp_val;
      short len,i;
      
      strcpy(ch,"#"); 
	
      tmp_val=global.puzzle_number;
      len=0;
      
      while(tmp_val>0)
      {
        tmp_val=tmp_val/10;
        len=len+1;
      }
      
      //  g_print("\ntmp value: %lu\n",tmp_val);
      tmp_val=global.puzzle_number;
      //  g_print("tmp value: %lu\n",tmp_val);
      
      for(i=1+len-1;i>=1;i--)
      {
        ch[i]=48+tmp_val%10;  
        tmp_val=tmp_val/10;
      }
      
      ch[1+len]='\0';

    
    }
    
    gdk_gc_set_foreground(gc,&color.conf_text);
    
    layout = gtk_widget_create_pango_layout (drawing_area, ch);
    fontdesc = pango_font_description_from_string (pick_box_font);
    pango_layout_set_font_description (layout, fontdesc); 
    pango_layout_get_pixel_size (layout, &text_w, &text_h);
    
    gdk_draw_layout (tmp_pxmp,gc,4,4,layout);
    pango_font_description_free (fontdesc);
    g_object_unref (layout);
    
    strcpy(ch,"www.yzonesoft.com");
    
    layout = gtk_widget_create_pango_layout (drawing_area, ch);
    fontdesc = pango_font_description_from_string (pick_box_font);
    pango_layout_set_font_description (layout, fontdesc); 
    //pango_layout_get_pixel_size (layout, &text_w, &text_h);
    
    gdk_draw_layout (tmp_pxmp,gc,4,4+text_h,layout);
    pango_font_description_free (fontdesc);
    g_object_unref (layout);

    
    
    
    pixbuf=gdk_pixbuf_new (colorspace, TRUE, 8,drawing_area_w,drawing_area_h);
  
    pixbuf=gdk_pixbuf_get_from_drawable (pixbuf,tmp_pxmp,colormap,
					   0,0,0,0,
					   drawing_area_w,drawing_area_h);
  
    gdk_pixbuf_save(pixbuf,(const char*)filename2,"png",&error,NULL);
    
    gdk_pixmap_unref(tmp_pxmp);
  }


  gtk_widget_destroy (export_puzzle);
  
  chdir("..");
  return TRUE;
}

//88export_as_png8888888888888888888888888888888888888888888888888888888888888888888888888888
//88open_saved_game88888888888888888888888888888888888888888888888888888888888888888888888888

gboolean open_saved_game(GtkWidget *widget)
{


  FILE *fp; 
  short i,j,k;

  struct variables
  {
   short number_of_picks;//18 or 32
   short board_size; //3 or 4
   short pencil_in[16][16][17];
   short p1_points;
   short p2_points;
   unsigned long puzzle_number;
   short number_of_free_boxes;
   struct pick pick[32];
   struct puzzle_box puzzle_box[16][16];
   struct timing timing;
   char player1_name[100];
   char player1_ini[5];
   char player2_name[100];
   char player2_ini[5];
   unsigned two_player_unlimited_total_time :1;
   unsigned two_player_time_game :1;
   unsigned two_player_game :1;
   unsigned time_race :1;
   unsigned whose_turn :1;
   unsigned disable_mouse :1;
   unsigned disable_keyboard :1;
   unsigned custom_puzzle :1;
   unsigned edit_modeF:1;
  }variable1;

  GtkWidget *open_game_dialog;
    chdir("save_dir");
  open_game_dialog = gtk_file_chooser_dialog_new ("Open Sudoku",
                                      NULL,
                                      GTK_FILE_CHOOSER_ACTION_OPEN,
                                      GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
                                      GTK_STOCK_OPEN, GTK_RESPONSE_ACCEPT,
                                      NULL);
  if(tag_id!=0)
  {
    g_source_remove(tag_id);
    tag_id=0;
  }

  if (gtk_dialog_run (GTK_DIALOG (open_game_dialog)) == GTK_RESPONSE_ACCEPT)
  {
    char *filename;
    filename = gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (open_game_dialog));
    fp=fopen(filename,"rb");
    fread(&variable1, sizeof(variable1),1,fp);
    fclose(fp);
    number_of_picks=variable1.number_of_picks;
    board_size=variable1.board_size;
    timing=variable1.timing;
    if(timing.wait_time==0)
      timing.wait_time=1;

    global.puzzle_number=variable1.puzzle_number;
    global.number_of_free_boxes=variable1.number_of_free_boxes;
    global.custom_puzzle=variable1.custom_puzzle;
    global.edit_modeF=variable1.edit_modeF;
    
    global.two_player_unlimited_total_time=variable1.two_player_unlimited_total_time;
    global.two_player_time_game=variable1.two_player_time_game;
    global.two_player_game=variable1.two_player_game;
    global.time_race=variable1.time_race;
    global.whose_turn=variable1.whose_turn;
    global.disable_mouse=variable1.disable_mouse;
    global.disable_keyboard=variable1.disable_keyboard;
    
    global.p1_points=variable1.p1_points;
    global.p2_points=variable1.p2_points;
    
    strcpy(sec_copy.player1_name,variable1.player1_name);
    strcpy(sec_copy.player1_ini,variable1.player1_ini);
    strcpy(sec_copy.player2_name,variable1.player2_name);
    strcpy(sec_copy.player2_ini,variable1.player2_ini);

    
    for(i=0;i<number_of_picks/2;i++)
    {
    for(j=0;j<number_of_picks/2;j++)
    {
      for(k=0;k<number_of_picks/2+1;k++)
        pencil_in[i][j][k]=variable1.pencil_in[i][j][k];
    }
    }
    
    for(i=0;i<number_of_picks/2;i++)
      pick[i]=variable1.pick[i];
    
    for(i=0;i<number_of_picks/2;i++)
    {
      for(j=0;j<number_of_picks/2;j++)
       puzzle_box[i][j]=variable1.puzzle_box[i][j];
    }

  
  

  gtk_widget_destroy (open_game_dialog);
  initialize_board();
  draw_puzzle();

  if(global.edit_modeF==TRUE)
    gtk_label_set_text(GTK_LABEL(status_bar_label_1),(const char*) "  Editor mode");
  else
    gtk_label_set_text(GTK_LABEL(status_bar_label_1),(const char*) "  ");
    
  if(global.two_player_game==TRUE)
    status_bar_update_tp_whoes_turn();

  update_status_bar_num_of_occupied_box();

  if(global.edit_modeF==FALSE)
  {
    if(global.custom_puzzle==TRUE)
      gtk_window_set_title (GTK_WINDOW (gs_main_window), "G-Sudoku #custom");
    else
      update_gsudoku_window_label_with_new_puzzle_number();
  }
  else
    gtk_window_set_title (GTK_WINDOW (gs_main_window), "G-Sudoku");
  
  global.two_player_time_game_dupe=global.two_player_time_game;
  
  if((global.two_player_game==TRUE && global.two_player_time_game==TRUE) || (global.two_player_game==FALSE && global.time_race==TRUE) )  
   switch_on_the_timer();
 
  delete_all_undo();
 
  if(global.two_player_game==FALSE)
    create_new_undo();
 
 }
 else
  gtk_widget_destroy (open_game_dialog);
 
 
 chdir("..");
 return TRUE;
}

//88open_saved_game88888888888888888888888888888888888888888888888888888888888888888888888888
//88save_game88888888888888888888888888888888888888888888888888888888888888888888888888888888

gboolean save_game(GtkWidget *widget)
{

  FILE *fp; 
  short i,j,k;

  struct variables
  {
   short number_of_picks;//18 or 32
   short board_size; //3 or 4
   short pencil_in[16][16][17];
   short p1_points;
   short p2_points;
   unsigned long puzzle_number;
   short number_of_free_boxes;
   struct pick pick[32];
   struct puzzle_box puzzle_box[16][16];
   struct timing timing;
   char player1_name[100];
   char player1_ini[5];
   char player2_name[100];
   char player2_ini[5];
   unsigned two_player_unlimited_total_time :1;
   unsigned two_player_time_game :1;
   unsigned two_player_game :1;
   unsigned time_race :1;
   unsigned whose_turn :1;
   unsigned disable_mouse :1;
   unsigned disable_keyboard :1;
   unsigned custom_puzzle :1;
   unsigned edit_modeF:1;
  }variable1;




  GtkWidget *save_game_dialog;

    chdir("save_dir");
  
  save_game_dialog = gtk_file_chooser_dialog_new ("Save Sudoku",
                                      NULL,
                                      GTK_FILE_CHOOSER_ACTION_SAVE,
                                      GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
                                      GTK_STOCK_SAVE, GTK_RESPONSE_ACCEPT,
                                      NULL);

  if(gtk_dialog_run (GTK_DIALOG (save_game_dialog)) == GTK_RESPONSE_ACCEPT)
  {
    char *filename;
    char filename2[255];
    filename = gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (save_game_dialog));
    strcpy(filename2,filename);
    strcat(filename2,".gsu");
    
    variable1.number_of_picks=number_of_picks;
    variable1.board_size=board_size;
    variable1.timing=timing;
    variable1.puzzle_number=global.puzzle_number;
    variable1.number_of_free_boxes=global.number_of_free_boxes;
    
    variable1.two_player_unlimited_total_time=global.two_player_unlimited_total_time;
    variable1.two_player_time_game=global.two_player_time_game;
    variable1.two_player_game=global.two_player_game;
    variable1.time_race=global.time_race;
    variable1.whose_turn=global.whose_turn;
    variable1.disable_mouse=global.disable_mouse;
    variable1.disable_keyboard=global.disable_keyboard;
    variable1.custom_puzzle=global.custom_puzzle;
    variable1.edit_modeF=global.edit_modeF;

    variable1.p1_points=global.p1_points;
    variable1.p2_points=global.p2_points;
    
    strcpy(variable1.player1_name,sec_copy.player1_name);
    strcpy(variable1.player1_ini,sec_copy.player1_ini);
    strcpy(variable1.player2_name,sec_copy.player2_name);
    strcpy(variable1.player2_ini,sec_copy.player2_ini);


    for(i=0;i<number_of_picks/2;i++)
    {
    for(j=0;j<number_of_picks/2;j++)
    {
      for(k=0;k<number_of_picks/2+1;k++)
        variable1.pencil_in[i][j][k]=pencil_in[i][j][k];
    }
    }
    
    for(i=0;i<number_of_picks/2;i++)
     variable1.pick[i]=pick[i];
    
    for(i=0;i<number_of_picks/2;i++)
    {
      for(j=0;j<number_of_picks/2;j++)
        variable1.puzzle_box[i][j]=puzzle_box[i][j];
    } 
    
    
    fp=fopen(filename2,"wb");
    fwrite(&variable1, sizeof(variable1),1,fp);
    fclose(fp);
    
    
  }
    chdir("..");
  gtk_widget_destroy (save_game_dialog);
return TRUE;
}

//88save_game88888888888888888888888888888888888888888888888888888888888888888888888888888888
//88selection_handle_text_entry88888888888888888888888888888888888888888888888888888888888888

gboolean selection_handle_text_entry(GtkWidget *text_entry,  GdkEventKey *event, gpointer data)
{

  int key_pressed;
  short event_state;
  char str[20];
  short len,i;
  unsigned long num;
 
  //g_print("%d  %d  %s\n",event->keyval,event->state,event->string);
  key_pressed=event->keyval;
  event_state=event->state;

  
  if(key_pressed==65293)
  {
   
    gtk_widget_hide (game_selection_dialog);
            
    puzzle_flag_init(FLAGS_FOR_OTHERS);

    initialize_board();

                
      global.puzzle_number=num;
     
        
    popup_dialog_generator();

    
    if(global.abort_generator==FALSE  &&  global.invalid_puzzleF==FALSE)
    {
      update_gsudoku_window_label_with_new_puzzle_number();
      start_puzzle_using_settings(); 
    } 
    
    return TRUE;
  }
 
  if( key_pressed>=48 &&  key_pressed<=57 )
  {  
   
    strcpy(str,gtk_entry_get_text(GTK_ENTRY(text_entry)));
    len=strlen(str);
    
    if(len<9)
      return FALSE;
    else
    {
      if(len==10)
        return TRUE;
      str[len]=key_pressed;
      str[len+1]='\0';
//      g_print("str: %s  %c\n",str,key_pressed);
      
	   
      if(str[0]<'4')
        return FALSE;
      else if(str[0]>'4')
        return TRUE;
      
      else if(str[1]<'2')
        return FALSE;
      else if(str[1]>'2')
        return TRUE;
      
      else if(str[2]<'9')
        return FALSE;
      else if(str[2]>'9')
        return TRUE;
      
      else if(str[3]<'4')
        return FALSE;
      else if(str[3]>'4')
        return TRUE;
      
      else if(str[4]<'9')
        return FALSE;
      else if(str[4]>'9')
        return TRUE;
      
      else if(str[5]<'6')
        return FALSE;
      else if(str[5]>'6')
        return TRUE;
      
      else if(str[6]<'7')
        return FALSE;
      else if(str[6]>'7')
        return TRUE;
      
      else if(str[7]<'2')
        return FALSE;
      else if(str[7]>'2')
        return TRUE;
      
      else if(str[8]<'9')
        return FALSE;
      else if(str[8]>'9')
        return TRUE;
      
      else if(str[9]<='5')
        return FALSE;
      else if(str[9]>'5')
        return TRUE;
      
      
	
    }  
       
  }
  else if(key_pressed==65288 || key_pressed==65535 || (key_pressed>=65361 &&  key_pressed<=65364) )
    return FALSE;
  else
    return TRUE;

}

//88selection_handle_text_entry88888888888888888888888888888888888888888888888888888888888888
//88select_game888888888888888888888888888888888888888888888888888888888888888888888888888888

gboolean select_game(GtkWidget *widget)
{
  
  char str[20];
  short len,i;
  long num;
  
  GtkWidget *text_entry;
  GtkWidget *table;
  GtkWidget *label;
  
  gint response;

  game_selection_dialog=gtk_dialog_new_with_buttons ("Select Puzzle",NULL,                                  GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT, GTK_STOCK_OK, GTK_RESPONSE_OK, GTK_STOCK_CANCEL,GTK_RESPONSE_CANCEL, NULL);
  
  gtk_window_set_default_size(GTK_WINDOW(game_selection_dialog),200,120);
  
  table = gtk_table_new (2, 1, FALSE);
  gtk_box_pack_end (GTK_BOX (GTK_DIALOG (game_selection_dialog)->vbox),table, FALSE, TRUE, 0);
  gtk_container_set_border_width(GTK_CONTAINER(table),20);
  gtk_table_set_row_spacings (GTK_TABLE (table),6);
  gtk_table_set_col_spacings (GTK_TABLE (table),24);

  label=gtk_label_new( (const char*)"range: 0 to 4294967295");
  gtk_misc_set_alignment (GTK_MISC(label),0,0.5);
  gtk_table_attach(GTK_TABLE (table),label,0,1,0,1,GTK_SHRINK|GTK_FILL,GTK_SHRINK|GTK_FILL,0,0);
  gtk_widget_show (label);

  text_entry=gtk_entry_new();
  gtk_table_attach_defaults (GTK_TABLE (table), text_entry, 0, 1, 1, 2);
  gtk_widget_show (text_entry);
  g_signal_connect (G_OBJECT (text_entry), "key_press_event",G_CALLBACK (selection_handle_text_entry),NULL);
 
  gtk_widget_show (table);
   
  response=gtk_dialog_run (GTK_DIALOG (game_selection_dialog));
  
  if(response==GTK_RESPONSE_OK)
  {
     strcpy(str,gtk_entry_get_text(GTK_ENTRY(text_entry)));
     len=strlen(str);
     num=0;
     
     for(i=0;i<len;i++)
       num=num*10+(str[i]-48);
  }
  
  gtk_widget_destroy (game_selection_dialog);
  
  if(response==GTK_RESPONSE_OK)
  {
  
    puzzle_flag_init(FLAGS_FOR_OTHERS);

    initialize_board();

                
     global.puzzle_number=num;
    
        
    popup_dialog_generator();

    
    if(global.abort_generator==FALSE  &&  global.invalid_puzzleF==FALSE)
    {
      update_gsudoku_window_label_with_new_puzzle_number();
      start_puzzle_using_settings(); 
    } 
  }
  
  return TRUE;

}

//88select_game888888888888888888888888888888888888888888888888888888888888888888888888888888
//88delete_event88888888888888888888888888888888888888888888888888888888888888888888888888888

gboolean delete_event( GtkWidget *widget, GdkEvent  *event, gpointer   data )
{
    exit_game();
    return FALSE;
}

//88delete_event88888888888888888888888888888888888888888888888888888888888888888888888888888
//88destroy_given_widget888888888888888888888888888888888888888888888888888888888888888888888

gboolean destroy_given_widget(GtkWidget *widget, GdkEvent  *event, gpointer   data)
{
  gtk_widget_destroy(widget);
  return TRUE;
}

//88destroy_given_widget888888888888888888888888888888888888888888888888888888888888888888888
//88expose_event88888888888888888888888888888888888888888888888888888888888888888888888888888
/* Redraw the screen from the backing pixmap */

gboolean expose_event( GtkWidget *widget, GdkEventExpose *event )
{
  
  gdk_draw_pixmap(widget->window,
                  widget->style->fg_gc[GTK_WIDGET_STATE (widget)],
                  pixmap,
                  event->area.x, event->area.y,
                  event->area.x, event->area.y,
                  event->area.width, event->area.height);


  return TRUE;

}

//88expose_event88888888888888888888888888888888888888888888888888888888888888888888888888888
//88goto_editor888888888888888888888888888888888888888888888888888888888888888888888888888888

gboolean goto_editor(GtkWidget *widget)
{
  
  short i,j,k;


  puzzle_flag_init(FLAGS_FOR_GOTO_EDITOR);
  initialize_board();
  
  for(i=0;i<number_of_picks/2;i++)
  {
  for(j=0;j<number_of_picks/2;j++)
  {
    
    for(k=0;k<number_of_picks/2+1;k++)
      pencil_in[i][j][k]=-1;
  }
  }

  for(i=0;i<number_of_picks/2;i++)
  {
  for(j=0;j<number_of_picks/2;j++)
  {
     puzzle_box[i][j].value=-1;
     puzzle_box[i][j].type=0;      
  }
  }
  
  global.number_of_free_boxes=board_size*board_size*board_size*board_size;
  update_status_bar_num_of_occupied_box();
  
  gtk_window_set_title (GTK_WINDOW (gs_main_window), "G-Sudoku");  
//  initialize_board();
  draw_puzzle();
  create_new_undo();
  gtk_label_set_text(GTK_LABEL(status_bar_label_1),(const char*) "  Editor mode");
  return TRUE;
  
}

//88goto_editor888888888888888888888888888888888888888888888888888888888888888888888888888888
//88solve888888888888888888888888888888888888888888888888888888888888888888888888888888888888

gboolean solve(GtkWidget *widget)
{
  check_all_conflicts();
  if(global.is_there_conflictsF == FALSE)
    popup_dialog_solver();
  return TRUE;

}

//88solve888888888888888888888888888888888888888888888888888888888888888888888888888888888888
//88check_conflicts88888888888888888888888888888888888888888888888888888888888888888888888888

gboolean check_conflicts(GtkWidget *widget)
{
  check_all_conflicts();
  return TRUE;

}

//88check_conflicts88888888888888888888888888888888888888888888888888888888888888888888888888
//88solver_thread2888888888888888888888888888888888888888888888888888888888888888888888888888

gpointer solver_thread2(gpointer data)
{
  global.have_solution=TRUE;
  global.have_to_guess=FALSE;
  solver(1);
  if(global.abort_generator==FALSE)
    gtk_widget_hide(tmp_message_dialog);
  return NULL;
}

//88solver_thread2888888888888888888888888888888888888888888888888888888888888888888888888888
//88play8888888888888888888888888888888888888888888888888888888888888888888888888888888888888

gboolean play(GtkWidget *widget)
{
  short i,j;
 
  GError *thread_err=NULL;
  GtkWidget *message_dialog;
  gboolean valid_sudoku_puzzle=TRUE;
  gint response;

  
  ur=NULL;
  if(global.editor_check_puzzle_validity==FALSE)
    valid_sudoku_puzzle=TRUE;
 
  global.keyboard_presentF=FALSE;
 
  if(tag_id!=0)
  {
    g_source_remove(tag_id);
    tag_id=0;
  }

 
  if(global.editor_check_puzzle_validity==TRUE)
  { 
 
   check_all_conflicts();
   if(global.is_there_conflictsF ==TRUE)
   {
     valid_sudoku_puzzle=FALSE;
     message_dialog = gtk_message_dialog_new (NULL,
                                  GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT,
                                  GTK_MESSAGE_ERROR,
                                  GTK_BUTTONS_OK,(const char*)"The puzzle contains conflicts, solve the conflicts first.");

     gtk_window_set_title (GTK_WINDOW (message_dialog), "Conflict Check");

     gtk_dialog_run (GTK_DIALOG (message_dialog));
     gtk_widget_destroy (message_dialog);

   }
   else
   {
       
      tmp_message_dialog = gtk_message_dialog_new (NULL,
                                  GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT,
                                  GTK_MESSAGE_INFO,
                                  GTK_BUTTONS_CANCEL,(const char*)"Checking if the puzzle entered is true sudoku puzzle");
      global.abort_generator=FALSE;
          
      gtk_window_set_title (GTK_WINDOW (tmp_message_dialog), "Message");      
      
      if((thread=g_thread_create((GThreadFunc)solver_thread2,NULL,TRUE,&thread_err))==NULL)
      {
         g_print("thread creation fail\n");
         g_error_free(thread_err);
      }
 
      response=gtk_dialog_run (GTK_DIALOG (tmp_message_dialog));
      global.abort_generator=TRUE;
 
      gtk_widget_destroy (tmp_message_dialog);

      if(response!=GTK_RESPONSE_CANCEL)
      {
        if(global.have_to_guess==TRUE && global.have_solution==TRUE)
        { 
           valid_sudoku_puzzle=FALSE;
           message_dialog = gtk_message_dialog_new (NULL,
                                  GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT,
                                  GTK_MESSAGE_ERROR,
                                  GTK_BUTTONS_OK,(const char*)"The puzzle has a valid solution, but the solution need guesses which is not considered as a valid sudoku puzzle. Try giving more clues.");

           gtk_window_set_title (GTK_WINDOW (message_dialog), "Puzzle Validation");

           gtk_dialog_run (GTK_DIALOG (message_dialog));
           gtk_widget_destroy (message_dialog);
      
        }
 
        if(global.have_solution==FALSE)
        { 
           valid_sudoku_puzzle=FALSE;
           valid_sudoku_puzzle=FALSE;
           message_dialog = gtk_message_dialog_new (NULL,
                                  GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT,
                                  GTK_MESSAGE_ERROR,
                                  GTK_BUTTONS_OK,(const char*)"The given sudoku puzzle does not have a valid solution.");

           gtk_window_set_title (GTK_WINDOW (message_dialog), "Puzzle Validation");

           gtk_dialog_run (GTK_DIALOG (message_dialog));
           gtk_widget_destroy (message_dialog);
 
        }
      }
 
    }

  }
  
  
  if(valid_sudoku_puzzle==TRUE)
  {
   
    for(i=0;i<number_of_picks/2;i++)
    {
    for(j=0;j<number_of_picks/2;j++)
    {
      if(puzzle_box[i][j].value !=-1)	
        puzzle_box[i][j].type=1;
    }
    }

    gtk_label_set_text(GTK_LABEL(status_bar_label_1),(const char*) "  ");
    gtk_window_set_title (GTK_WINDOW (gs_main_window), "G-Sudoku #custom");

    puzzle_flag_init(FLAGS_FOR_EDITOR);
  
    initialize_board();
    draw_puzzle();

    start_puzzle_using_settings();   
  
  }
 
  return TRUE;

}

//88play8888888888888888888888888888888888888888888888888888888888888888888888888888888888888
//88check_the_solution88888888888888888888888888888888888888888888888888888888888888888888888

gboolean check_the_solution(GtkWidget *widget)
{
  const gchar *message="The solution you have given is wrong. solve all the conflicts and try again.";
  const gchar *message2="There are empty cells, please fill all the cell.\n\nNote: doubt text are consider as empty cells, you can change this setting in preferences";
  const gchar *message3="Solution is valid. You Win. Congratulations.";

  GtkWidget *message_dialog;
 
 
  check_all_conflicts();
 
  if(global.number_of_free_boxes!=0)
  {
     message_dialog = gtk_message_dialog_new (NULL,
                                  GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT,
                                  GTK_MESSAGE_ERROR,
                                  GTK_BUTTONS_OK,message2);

     gtk_window_set_title (GTK_WINDOW (message_dialog), "Puzzle Fill Check");
				  
     gtk_dialog_run (GTK_DIALOG (message_dialog));
     gtk_widget_destroy (message_dialog);
 
  }
  else
  {
     if(global.is_there_conflictsF ==TRUE)
     {
        message_dialog = gtk_message_dialog_new (NULL,
                                  GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT,
                                  GTK_MESSAGE_ERROR,
                                  GTK_BUTTONS_OK,message);

        gtk_window_set_title (GTK_WINDOW (message_dialog), "Solution Check");
				  
        gtk_dialog_run (GTK_DIALOG (message_dialog));
        gtk_widget_destroy (message_dialog);

      }
      else
      {
         message_dialog = gtk_message_dialog_new (NULL,
                                  GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT,
                                  GTK_MESSAGE_INFO,
                                  GTK_BUTTONS_OK,message3);

        gtk_window_set_title (GTK_WINDOW (message_dialog), "Congratulations");
				  
         gtk_dialog_run (GTK_DIALOG (message_dialog));
         gtk_widget_destroy (message_dialog);
 
 
      }
  }
   
  return TRUE;

}

//88check_the_solution88888888888888888888888888888888888888888888888888888888888888888888888
//88one_player_game88888888888888888888888888888888888888888888888888888888888888888888888888

gboolean one_player_game(GtkWidget *widget)
{
  
  puzzle_flag_init(FLAGS_FOR_ONE_PLAYER_GAME);
  
  initialize_board();
 
 
  grand=g_rand_new();

  global.puzzle_number=g_rand_int(grand);

 
  popup_dialog_generator();
 
  global.keyboard_presentF=FALSE;
 
  if(global.abort_generator==FALSE  &&  global.invalid_puzzleF==FALSE)
  {
     update_gsudoku_window_label_with_new_puzzle_number();
     start_puzzle_using_settings(); 
  } 
  
  return TRUE;

}

//88one_player_game88888888888888888888888888888888888888888888888888888888888888888888888888
//88two_player_game88888888888888888888888888888888888888888888888888888888888888888888888888

gboolean two_player_game(GtkWidget *widget)
{


  puzzle_flag_init(FLAGS_FOR_TWO_PLAYER_GAME);

  initialize_board();


  grand=g_rand_new();

   global.puzzle_number=g_rand_int(grand);
 
  popup_dialog_generator();

 if(global.abort_generator==FALSE  &&  global.invalid_puzzleF==FALSE)
 {
    update_gsudoku_window_label_with_new_puzzle_number();
    start_puzzle_using_settings();
 }
 

 return TRUE;
 
}

//88two_player_game88888888888888888888888888888888888888888888888888888888888888888888888888
//88new_random_game88888888888888888888888888888888888888888888888888888888888888888888888888

gboolean new_random_game(GtkWidget *widget)
{

  puzzle_flag_init(FLAGS_FOR_OTHERS);



  grand=g_rand_new();
 
   global.puzzle_number=g_rand_int(grand);
 
//  if(global.show_console_messegesF==TRUE)
//    g_print("puzzle_number: %lu\n",global.puzzle_number);
  
  initialize_board();
  popup_dialog_generator();

 
  if(global.abort_generator==FALSE  &&  global.invalid_puzzleF==FALSE)
  {
     update_gsudoku_window_label_with_new_puzzle_number();
     start_puzzle_using_settings();
  }
  return TRUE;

}

//88new_random_game88888888888888888888888888888888888888888888888888888888888888888888888888
//8888888888888888888888888888888888888888888888888888888888888888888888888888888888888888888




